function obj = generateCouplingmatrix(obj)
% GENERATECOUPLINGMATRIX recompute the couplingmatrix
% 
% objlss = objlss.generateCouplingmatrix()
% 
% ---------------------------------------------------------------------------
% DESCRIPTION
% ---------------------------------------------------------------------------  
% Return an lss object where the couplingmatrix has been recomputed
% 
% objlss = objlss.GETCOUPLINGMATRIX
%     
% ---------------------------------------------------------------------------
% OUTPUT
% ---------------------------------------------------------------------------
% 
% lss object
% 

% Copyright is with the following author(s):
%
% (C) 2013 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso(at)unipv.it, giancarlo.ferrari(at)unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end
    
    for i=1:obj.numSys
        for j=1:obj.numSys
            a=~all(all(obj.A(sum(obj.ni(1:i-1))+1:sum(obj.ni(1:i)),sum(obj.ni(1:j-1))+1:sum(obj.ni(1:j)))==0));
            if isempty(obj.B)
                b = false;
            else
                b = ~all(all(obj.B(sum(obj.ni(1:i-1))+1:sum(obj.ni(1:i)),sum(obj.mi(1:j-1))+1:sum(obj.mi(1:j)))==0));
            end
            
            if isempty(obj.pi)
                pi = obj.ni;
            else
                pi = obj.pi;
            end
            
            if isempty(obj.C)
                if i==j
                    c = true;
                else
                    c = false;
                end
            else
                c = ~all(all(obj.C(sum(pi(1:i-1))+1:sum(pi(1:i)),sum(obj.ni(1:j-1))+1:sum(obj.ni(1:j)))==0));
            end
            
            if isempty(obj.D)
                d = false;
            else
                d = ~all(all(obj.D(sum(pi(1:i-1))+1:sum(pi(1:i)),sum(obj.mi(1:j-1))+1:sum(obj.mi(1:j)))==0));
            end
            if a || b || c || d
                obj.couplingmatrix(i,j) = true;
            end
        end
    end
    
end