function [ Trucks1Dcenmpc ] = makeCenMPCTrucks1D(modelTrucks1Dd,options)
% MAKECENMPCTRUCKS1D create cenmpc controllers for model trucks in 1D
%

% Copyright is with the following author(s):
%
% (C) 2012 
%     Stefano Riverso, Alberto Battocchio, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end 
    
    if nargin<2
        options = sdpsettings('verbose',0);
    end

    NMPC = 10;
    Q    = eye(sum(modelTrucks1Dd.ni))*10;
    R    = eye(sum(modelTrucks1Dd.mi)+modelTrucks1Dd.numICen)*1;

    tic
    Trucks1Dcenmpc = cenmpc(modelTrucks1Dd,NMPC,[],options);
    time_cen = toc;
    
    Trucks1Dcenmpc = Trucks1Dcenmpc.zeroTerminal(Q,R);
    time_cen_stability = toc;

    save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/cenmpc/1D/Trucks1Dcenmpc'],'Trucks1Dcenmpc','time_cen_stability','time_cen')

end