% EXAMPLE2CENMPC example of the use of class cenmpc
%

% Copyright is with the following author(s):
%
% (C) 2014 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear
close all

N = 3;

disp('# Create a large-scale system #')
[ modelTrucks1Dc, modelTrucks1Dd ] = makeModelTrucks1D_disturbances_bounded_cen(N);

disp('# Create robust centralized controller #')
[ Trucks1Dcenmpc ] = makeCenMPCTrucks1D_disturbances_bounded(modelTrucks1Dd);

disp('# Simulation #')
x0 = -1+rand(2*N,1)*2; x0(2:2:end) = 0;
[ x, u ] = runSimTrucks1D_disturbances_bounded_cen(30,x0,modelTrucks1Dc,modelTrucks1Dd,Trucks1Dcenmpc);