% EXAMPLE1 of epsilon_mRPI class
%
% W is a polyhedron object
%
%
% see also EPSILON_MRPI

% Copyright is with the following author(s):
%
% (C) 2014
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
% (C) 2012 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------


global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

clear
close

% matrices of the LTI system
A  = [ 1 1 ; 0 1 ];
B  = [ 1 ; 1 ];
K  = -[1.17 1.03];

% bounded disturbances as Polyhedron object
W = Polyhedron([ eye(2) ; -eye(2) ],[ 1 1 1 1 ]');

% approximation
epsilon = 5*10^-5;

% create an object F that is a epsilon-mRPI for the closed loop LTI system
% with dynamic A+BK and disturbances bounded in W (W is a Polyhedron object)
F  = epsilon_mRPI(A+B*K,W,epsilon)

% Otherwise one can create an object F that is a epsilon-mRPI for the 
% closed loop LTI system with dynamic A+BK and disturbances bounded in W 
% (W is a zonotope object)
% W = zonotope([-0.5 0.1]',eye(2));
% F = epsilon_mRPI(A+B*K,W,epsilon);

% plot the approximation of the mRPI
F.plot