% EXAMPLE2 of epsilon_mRPI class
%
% W is a polyhedron object
% X is a polyhedron object
%
%
% see also EPSILON_MRPI

% Copyright is with the following author(s):
%
% (C) 2014 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
% (C) 2012 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

clear
close

A  = [ 1 1 ; 0 1 ];
B  = [ 1 ; 1 ];
K  = -[1.17 1.03];
W = Polyhedron([ eye(2) ; -eye(2) ],[ 1 1 1 1 ]');
X = Polyhedron([ eye(2) ; -eye(2) ],[ 2 2 2 2 ]');

epsilon = 5*10^-5;

disp('In this example, an error occurs because the outer')
disp('approximation of the minimal RPI is not inside X')
F  = epsilon_mRPI(A+B*K,W,epsilon,X)