% EXAMPLE1 of localControlLyapunov class
%
%
% see also LOCALCONTROLLYAPUNOV

% Copyright is with the following author(s):
%
% (C) 2012 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

clear
close

% matrices of the LTI system
A  = [ 1 1 ; 0 1 ];
B  = [ 0 ; 1 ];

% matrices for constraints on state and input variables
cx = [ eye(2) ; -eye(2) ];
dx = [ 2 2 1.5 2 ]';
cu = [ 1 ; -1 ];
du = [ 3 ; 3 ];

% parameter of the algorithm, >= controllability index
k  = 3;

% x0 is a parameter of the algorithm
% As x0 we consider the vertices of polytope = {x|cx*x<=dx}
x0 = [2 2;-1.5 2;-1.5 -2;2 -2];

% create the lambda contractive control invariant set
L  = localControlLyapunov(A,B,k,{cx,dx},{cu,du},x0)

% plot the lambda contractive control invariant set
L.plot

% Contractiveness
lambda = L.lambda