% EXAMPLE 1 of lss class
%
%
% see also LSS

% Copyright is with the following author(s):
%
% (C) 2012 
%     Alberto Battocchio, Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

disp('Example 1: Two coupled mass-spring-damper systems')

M = 5;   % mass
k = 0.5; % elastic constant of the springs
h = 5;   % damping coefficient

% creation of an empty lss object
modelCart = lss;

A = [ 0 , 1; -k/M , -h/M ]; B=[ 0; 100/M];

% system 1
modelCart = modelCart.addSystem(A,B);

% system 2
modelCart = modelCart.addSystem (A,B);

% coupling among subsystems 1 and 2
Aij = [ 0 , 0 ; k/M , h/M ];
modelCart = modelCart.addCoupling(1,2,Aij);
modelCart = modelCart.addCoupling(2,1,Aij);

% plot graph of subsystems
modelCart.plot