% EXAMPLE 2 of lss class
%
%
% see also LSS

% Copyright is with the following author(s):
%
% (C) 2012 
%     Alberto Battocchio, Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

disp('Example 2: Two coupled mass-spring-damper systems with exogenous signals and centralized inputs')

example1lss;
% specify how exogenous input number 1 affects system 1 (creation of M)
modelCart = modelCart.addExoInput ([0;1],[], 1,1);

% specify how exogenous input number 1 affects system 2 (creation of M)
modelCart = modelCart.addExoInput ([16;2],[],2,1);

% specify how exogenous input number 2 affects system 2 (creation of M)
modelCart = modelCart.addExoInput ([0;3],[],2,2);

% instead of calling addExoInput three times we can use
% modelCart = modelCart.addExoInput ([0 0; 1 0; 16 0; 2 3],[]);

% specify how centralized input number 1 affects system 1 (creation of Bcen)
modelCart = modelCart.addCentralizedInput([0;4],[],1,1);

% specify how centralized input number 1 affects system 2 (creation of Bcen)
modelCart = modelCart.addCentralizedInput ([0;5],[],2,1);

% instead of the previous calls to addCentralizedInput we can use
% modelCart = modelCart.addCentralizedInput ([0;4;0;5],[]);

% plot all signals
modelCart.plot([],'all')