% EXAMPLE 3 of lss class
%
%
% see also LSS

% Copyright is with the following author(s):
%
% (C) 2012 
%     Alberto Battocchio, Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

disp('Example 3: String of 1000 mass-spring-damper systems')

N     = 1000;
minM  = 1;
maxM  = 10;
mink  = 0.1;
maxk  = 0.9;
minh  = 0.1;
maxh  = 10;

M = minM+rand(1,N)*(maxM-minM);
k = mink+rand(1,N-1)*(maxk-mink);
h = minh+rand(1,N-1)*(maxh-minh);

modelCart = lss;
modelCart = modelCart.addSystem([0,1;-k(1)/M(1),-h(1)/M(1)],[0;100/M(1)],[1 0],0);
for i=2:N-1
    modelCart = modelCart.addSystem([0,1;-(k(i-1)+k(i))/M(i),-(h(i-1)+h(i))/M(i)],[0;100/M(i)],[1 0],0);
    modelCart = modelCart.addCoupling(i-1,i,[0,0;k(i-1)/M(i-1),h(i-1)/M(i-1)],zeros(2,1));
    modelCart = modelCart.addCoupling(i,i-1,[0,0;k(i-1)/M(i),h(i-1)/M(i)],zeros(2,1));
end
modelCart = modelCart.addSystem([0,1;-k(N-1)/M(N),-h(N-1)/M(N)],[0;100/M(N)],[1 0],0);
modelCart = modelCart.addCoupling(N,N-1,[0,0;k(N-1)/M(N),h(N-1)/M(N)],zeros(2,1));
modelCart = modelCart.addCoupling(N-1,N,[0,0;k(N-1)/M(N-1),h(N-1)/M(N-1)],zeros(2,1));