% EXAMPLE 4 of lss class
%
%
% see also LSS

% Copyright is with the following author(s):
%
% (C) 2012 
%     Alberto Battocchio, Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

disp('Example 4: Two coupled mass-spring-damper systems with exogenous signals and centralized inputs and constraints')

example2lss;

% 0(x_3)+1(x_4)<=3
modelCart = modelCart.addStateConstraint (2,[0,1],3);

% 2(x_3)+1(x_4)<=0 and 1(x_3)+3(x_4)<=5
modelCart = modelCart.addStateConstraint (2,[2,1;1,3],[0;5]);

% 0(x_1)+1(x_2)+1(x_3)+2(x_4)<=0 & 3(x_1)+2(x_2)+0(x_3)+1(x_4)<=5 
modelCart = modelCart.addStateConstraint ([1,2],[0,1,1,2;3,2,0,1],[0;5]);

% 2(u_2)<=3
modelCart = modelCart.addInputConstraint (2,2,3);

% 1(u_1)+2(u_2)<=3
modelCart = modelCart.addInputConstraint ([1,2],[1,2],3);

[Hx Kx] = modelCart.doubleStateConstraint(1)
disp('Hx and Kx are empty because there is no constraint affecting system 1 only')

[Hu Ku] = modelCart.doubleInputConstraint(2,1)
disp('Hu and Ku contain 2(u_2)<=3 and 1(u_1) + 2(u_2)<=3 because selection is 1 and we consider all the constraints related to system 2')