% EXAMPLE 5 of lss class
%
%
% see also LSS

% Copyright is with the following author(s):
%
% (C) 2012 
%     Alberto Battocchio, Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

disp('Example 5: Two coupled mass-spring-damper systems with exogenous input and centralized inputs and constraints, using remove operations')

example4lss;

% remove exogenous input number 2
modelCart = modelCart.removeExoInput(2);

% remove centralized input number 1
modelCart = modelCart.removeCentralizedInput(1);

% remove coupling constraint on the state of system 1 and 2
modelCart = modelCart.removeConstraint([1,2],'state');

% remove dynamic coupling between 1 and 2 so A12 = zeros
modelCart = modelCart.removeCoupling(1,2,'a');

% remove subsystem number 2
modelCart = modelCart.removeSystem(2);

% plot new system
modelCart.plot([],'all')