function [] = makePnpmpcControllersPNS( controller )
% MAKEPNPMPCCONTROLLERSPNS create pnpmpc controllers for power network systems of scenarios 1,2,3 with two different terminal regions
%
% Input parameter 'controller'
% 1 - Polytope State Constraints, Input Constraints, Decentralized design
% 2 - Polytope State Constraints, Decentralized design
% 3 - Polytope State Constraints, Distributed design
% 4 - Zonotope State Constraints, Input Constraints, Decentralized design
% 5 - Zonotope State Constraints, Decentralized design
% 6 - Zonotope State Constraints, Distributed design
%

% Copyright is with the following author(s):
%
% (C) 2013 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
% (C) 2012 
%     Stefano Riverso, Alberto Battocchio, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------
    
    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end
    
    if controller<1 || controller>6
        error('MAKEPNPMPCCONTROLLERSPNS: controller must be between 1 and 6')
    end
    
    makeScenariosPNS
    
    switch(controller)
        case 1
            pnsCtrl1
        case 2
            pnsCtrl2
        case 3
            pnsCtrl3
        case 4
            pnsCtrl4
        case 5
            pnsCtrl5
        case 6
            pnsCtrl6
    end
    
end