function [] = scenario1Full(options)
% SCENARIO1FULL simulate scenario 1 in a decentralized or distributed fashion quadratic terminal region 
%

% Copyright is with the following author(s):
%
% (C) 2012 
%     Stefano Riverso, Alberto Battocchio, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------
    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end
    
    if nargin==0
        options = sdpsettings;
    end
    
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/pnsC1'])
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/pnsD1ss'])
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/simulationParameters'])
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/Dss_PNPMPC/full/ctrlPnpMpcFull'])
    
    
    
    if isempty(ctrlPnpMpcFull(1).Kij)
        [ x deltaPref ] = sim1PNS(ctrlPnpMpcFull,pnsD1ss,pnsC1,Tsim,x0,deltaPL,xref,uref,options);
        [ eta Phi ] = scenario1performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
        save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/Dss_PNPMPC/full/scenario1FullData_sim1PNS'],'x','deltaPref','deltaPL','pnsC1','eta','Phi','Tsim')
        
        if isa(ctrlPnpMpcFull(1).Z,'parameterizedRCI')
            [ x deltaPref ] = sim2PNS(ctrlPnpMpcFull,pnsD1ss,pnsC1,Tsim,x0,deltaPL,xref,uref,options);
            [ eta Phi ] = scenario1performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
            save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/Dss_PNPMPC/full/scenario1FullData_sim2PNS'],'x','deltaPref','deltaPL','pnsC1','eta','Phi','Tsim')
        end
    else
        [ x deltaPref ] = sim3PNS(ctrlPnpMpcFull,pnsD1ss,pnsC1,Tsim,x0,deltaPL,xref,uref,options);
        [ eta Phi ] = scenario1performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
        save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/Dss_PNPMPC/full/scenario1FullData_sim3PNS'],'x','deltaPref','deltaPL','pnsC1','eta','Phi','Tsim')
        
        if isa(ctrlPnpMpcFull(1).Z,'parameterizedRCI')
            [ x deltaPref ] = sim4PNS(ctrlPnpMpcFull,pnsD1ss,pnsC1,Tsim,x0,deltaPL,xref,uref,options);
            [ eta Phi ] = scenario1performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
            save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario1/Dss_PNPMPC/full/scenario1FullData_sim4PNS'],'x','deltaPref','deltaPL','pnsC1','eta','Phi','Tsim')
        end
    end
    
    
end