function [] = scenario3Zero(options)
% SCENARIO3ZERO simulate scenario 3 in a decentralized or distributed fashion with zero terminal constraint
%

% Copyright is with the following author(s):
%
% (C) 2012 
%     Stefano Riverso, Alberto Battocchio, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------
    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end
    
    if nargin==0
        options = sdpsettings;
    end
    
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/pnsC3'])
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/pnsD3ss'])
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/simulationParameters'])
    load([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/Dss_PNPMPC/zero/ctrlPnpMpcZero'])
    
    
    
    if isempty(ctrlPnpMpcZero(1).Kij)
        [ x deltaPref ] = sim1PNS(ctrlPnpMpcZero,pnsD3ss,pnsC3,Tsim,x0,deltaPL,xref,uref,options);
        [ eta Phi ] = scenario3performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
        save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/Dss_PNPMPC/zero/scenario3ZeroData_sim1PNS'],'x','deltaPref','deltaPL','pnsC3','eta','Phi','Tsim')
        
        if isa(ctrlPnpMpcZero(1).Z,'parameterizedRCI')
            [ x deltaPref ] = sim2PNS(ctrlPnpMpcZero,pnsD3ss,pnsC3,Tsim,x0,deltaPL,xref,uref,options);
            [ eta Phi ] = scenario3performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
            save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/Dss_PNPMPC/zero/scenario3ZeroData_sim2PNS'],'x','deltaPref','deltaPL','pnsC3','eta','Phi','Tsim')
        end
    else
        [ x deltaPref ] = sim3PNS(ctrlPnpMpcZero,pnsD3ss,pnsC3,Tsim,x0,deltaPL,xref,uref,options);
        [ eta Phi ] = scenario3performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
        save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/Dss_PNPMPC/zero/scenario3ZeroData_sim3PNS'],'x','deltaPref','deltaPL','pnsC3','eta','Phi','Tsim')
        
        if isa(ctrlPnpMpcZero(1).Z,'parameterizedRCI')
            [ x deltaPref ] = sim4PNS(ctrlPnpMpcZero,pnsD3ss,pnsC3,Tsim,x0,deltaPL,xref,uref,options);
            [ eta Phi ] = scenario3performance(x,deltaPref,xref,uref,blkdiag(Q,Q,Q,Q),blkdiag(R,R,R,R),Tsim);
            save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/modelPNS/scenario3/Dss_PNPMPC/zero/scenario3ZeroData_sim4PNS'],'x','deltaPref','deltaPL','pnsC3','eta','Phi','Tsim')
        end
    end
    
    
end