function [ x u ] = sim3PNS(objCtrl,objsysD,objsysC,Tsim,x0,exosignals,xref,uref,options)

    xsim = x0';
    usim = [];
    
    ni = objsysD.ni;
    mi = objsysD.mi;
    
    for t=0:Tsim-1
        
        fprintf('Running... Time: %d\n',t)
        
        uRH = zeros(objsysD.numSys,1);
        parfor i=1:objsysD.numSys
            xj    = [];
            jN = find(objsysD.couplingmatrix(i,[1:i-1,i+1:end])==1);
            for jj=1:length(jN)
                j = jN(jj);
                xj = [ xj ; x0(sum(ni(1:j-1))+1:sum(ni(1:j)),1) ] ;
            end
            uRH(i) = objCtrl(i).uRH(x0(sum(ni(1:i-1))+1:sum(ni(1:i)),1),xj,[],exosignals.signals.values(t+1,objCtrl(i).Exo),xref.signals.values(t+1,sum(ni(1:i-1))+1:sum(ni(1:i)),1)',uref.signals.values(t+1,sum(mi(1:i-1))+1:sum(mi(1:i)),1)',options);
        end
        
        x0ode = ode45(@(tt,x)simulatorPNS(tt,x,uRH,exosignals.signals.values(t+1,:)',objsysC),[0 objsysD.Ts],x0);
        x0 = x0ode.y(:,end);        
        
        xsim = [ xsim ; x0'  ];
        usim = [ usim ; uRH' ];
        
    end
    
    clear x u
    
    u.signals.values = usim;
    u.signals.dimensions = size(usim,2);
    u.time = 0:Tsim-1;
    
    x.signals.values = xsim;
    x.signals.dimensions = size(xsim,2);
    x.time = 0:Tsim;
    
end