% EXAMPLE1 of parameterizedRCI class
%
%
% see also PARAMETERIZEDRCI

% Copyright is with the following author(s):
%
% (C) 2012 
%     Stefano Riverso, Alberto Battocchio, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

global pnpmpcToolboxGlobalOptions;
if ~isstruct(pnpmpcToolboxGlobalOptions),
    pnpmpc_toolbox_err;
end

clear
close

% matrices of the LTI system
A  = [ 1 1 ; 0 1 ];
B  = [ 0 ; 1 ];

% matrices for constraints on state and input variables
cx = [ eye(2) ; -eye(2) ];
dx = [ 2 2 1.5 2 ]';
cu = [ 1 ; -1 ];
du = [ 3 ; 3 ];

% parameter of the algorithm, greater than the controllability index of (A,B)
k  = 5;

% x0 is a parameter of the algorithm such that W \subseteq hull(x0)
x0 = [ 0.99 0.99 ; 0.99 -0.01 ; -0.01 -0.01 ; -0.01 0.99 ];

% create the parameterized robust control invariant set
R  = parameterizedRCI(A,B,k,{cx,dx},{cu,du},x0)

% plot the parameterized robust control invariant set
R.plot