function [ Trucks1Dpnpctrl, K ] = makePnpCtrlTrucks1D(modelTrucks1Dd,DeDi)
% MAKEPNPCTRLTRUCKS1D create pnp controllers for model trucks in 1D
%

% Copyright is with the following author(s):
%
% (C) 2014
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end
    
    if nargin<2
        DeDi = 0;
    end
    
    flag.Qi = 10*eye(modelTrucks1Dd.ni(1));
    flag.Ri = eye(modelTrucks1Dd.mi(1));
    
    if DeDi==1
        flag = repmat(flag,modelTrucks1Dd.numSys,1);
        for i=1:modelTrucks1Dd.numSys
            flag(i).distributedParents = setdiff(full(find(modelTrucks1Dd.couplingmatrix(i,:))),i);
        end
    end
    
    [ Trucks1Dpnpctrl, K ] = modelTrucks1Dd.createCtrlPnP(flag);
end