function [ Trucks2Dpnp ] = makePnpmpcTrucks2D(modelTrucks2Dd,options)
% MAKEPNPMPCTRUCKS2D create pnpmpc controllers for model trucks in 2D
%

% Copyright is with the following author(s):
%
% (C) 2012 
%     Stefano Riverso, Alberto Battocchio, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, alberto.battocchio01@universitadipavia.it,
%     giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

    global pnpmpcToolboxGlobalOptions;
    if ~isstruct(pnpmpcToolboxGlobalOptions),
        pnpmpc_toolbox_err;
    end 

    if nargin<2
        options = sdpsettings('verbose',0);
    end
    
    NMPC = 10;
    Q    = eye(modelTrucks2Dd.ni(1))*10;
    R    = eye(modelTrucks2Dd.mi(1))*1;

    tic
    Trucks2Dpnp = modelTrucks2Dd.createCtrlPnPMPC(NMPC,[],options);
    time_pnp = toc;
    parfor i=1:modelTrucks2Dd.numSys
        Trucks2Dpnp(i) = Trucks2Dpnp(i).zeroTerminal(Q,R);
    end
    time_pnp_stability = toc;

    save([pnpmpcToolboxGlobalOptions.pathInstalled '/examples/pnpmpc/2D/Trucks2Dpnp'],'Trucks2Dpnp','time_pnp_stability','time_pnp')

end