% EXAMPLE1PNPMPC example of the use of class pnpmpc
%

% Copyright is with the following author(s):
%
% (C) 2014 
%     Stefano Riverso, Giancarlo Ferrari Trecate
%     Identification and Control of Dynamic Systems Laboratory,
%     Universita' degli Studi di Pavia, Italy
%     stefano.riverso@unipv.it, giancarlo.ferrari@unipv.it
%

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% ---------------------------------------------------------------------------

clear
close all

N = 5;

disp('# Create a large-scale system #')
[ modelTrucks1Dc, modelTrucks1Dd ] = makeModelTrucks1D(N);

disp('# Create decentralized pnpmpc controllers #')
[ Trucks1Dpnp ] = makePnpmpcTrucks1D(modelTrucks1Dd);

disp('# Simulation #')
x0 = -0.8+rand(2*N,1)*1.6;
[ x, u ] = runSimTrucks1D(30,x0,modelTrucks1Dc,modelTrucks1Dd,Trucks1Dpnp);