function pnpmpc_toolbox_init()
    global pnpmpcToolboxGlobalOptions;
    
    pnpmpcToolboxGlobalOptions.pathInstalled = fileparts(which('pnpmpc_toolbox_init.m'));
    pnpmpcToolboxGlobalOptions.version       = 'S.R';
    
    fprintf('######################################\n')
    fprintf('#                                    #\n')
    fprintf('#          PnPMPC-toolbox            #\n')
    fprintf('#            version %s             #\n',pnpmpcToolboxGlobalOptions.version)
    fprintf('#                                    #\n')
    fprintf('######################################\n')
    fprintf('Copyright (C) 2012-%s by S. Riverso, A. Battocchio and G. Ferrari-Trecate\n\n',datestr(now,'yyyy'))
    fprintf('Send bug reports, questions or comments to pnpmpc_toolbox@unipv.it\n')
    fprintf('For news, visit the PnPMPC-toolbox web page http://sisdin.unipv.it/pnpmpc/pnpmpc.php\n\n')
    
    % check installed toolboxes
    testToolbox = ver;
    controlToolbox = [];
    optToolbox = [];
    symbolicToolbox = [];
    for i=1:length(testToolbox)
        if strcmp(testToolbox(1,i).Name,'Control System Toolbox')
            controlToolbox = testToolbox(1,i);
            continue;
        end
        if strcmp(testToolbox(1,i).Name,'Optimization Toolbox')
            optToolbox = testToolbox(1,i);
            continue;
        end
        if strcmp(testToolbox(1,i).Name,'Symbolic Math Toolbox')
            symbolicToolbox = testToolbox(1,i);
            continue;
        end
    end
    if isstruct(controlToolbox)
        fprintf('Control System Toolbox          : installed\n')
    else
        fprintf('Control System Toolbox          : not found\n')
    end
    if isstruct(optToolbox)
        fprintf('Optimization Toolbox            : installed\n')
    else
        fprintf('Optimization Toolbox            : not found\n')
    end
    
    % check YALMIP
    yalmiplocation = which('yalmip.m', '-all');
    if ~isempty(yalmiplocation)
        fprintf('YALMIP                          : installed\n')
    else
        fprintf('YALMIP                          : not found\n')
    end
    
    % check MPT3
    mtp3location = which('mptopt.m','-all');
    if ~isempty(mtp3location)
        fprintf('MPT3                            : installed\n')
    else
        fprintf('MPT3                            : not found\n')
    end
    
    % check graphViz4Matlab
    graphViz4Matlablocation = which('graphViz4Matlab.m', '-all');
    if ~isempty(graphViz4Matlablocation)
        fprintf('graphViz4Matlab                 : installed\n')
    else
        fprintf('graphViz4Matlab                 : not found\n')
    end
    
    % check INTLAB
    INTLABlocation = which('startintlab.m', '-all');
    if ~isempty(INTLABlocation)
        fprintf('INTLAB                          : installed\n')
    else
        fprintf('INTLAB                          : not found\n')
    end
    
    % check Symbolic Math Toolbox
    if isstruct(symbolicToolbox)
        fprintf('Symbolic Math Toolbox           : installed\n')
    else
        fprintf('Symbolic Math Toolbox           : not found\n')
    end
    
    fprintf('\n\n')
    
end